' THIS IS THE OLD VERSION OF FONT.BI - IT ISN'T USED ANY LONGER IN LENGUA
' (but maybe it's helpful for other projects, when you need a simple library)

#include once "fbgfx.bi"
#include once "utf_conv.bi"

namespace FONTSIZE
  const NORMAL = 18, HEADLINE = 20, SMALL = 16, X_SMALL = 14, TINY = 12, BUTTON = 13
end namespace

const MAX_TEXTSIZE = 999
#ifdef FBGFX_FALLBACK
  ' missing symbols from freetype.bi
  function FT_Init_FreeType(p as any ptr) as integer
    return 0
  end function
  type FT_Face as integer
  /'
  end type '/
  type TFT_Var
    ErrorMsg  as integer
    Library   as integer
    PixelSize as integer
  end type
#else
  #include once "freetype2/freetype.bi"
  ' alpha blending
  const FT_MASK_RB_32 = &h00ff00ff, FT_MASK_AG_32 = &hff00ff00
  type TFT_Var
    ErrorMsg  as FT_Error
    Library   as FT_Library
    PixelSize as integer
  end type
#endif

type TCoord
  as integer x, y
  declare constructor
  declare constructor(x_ as integer, y_ as integer)
end type
constructor TCoord
end constructor
constructor TCoord(x_ as integer, y_ as integer)
  x = x_
  y = y_
end constructor

dim shared FT_Var as TFT_Var

declare sub drawGlyph(img as FB.Image ptr, byval font as FT_Face, byval x as integer, byval y as integer, byval clr as uinteger)
declare function FTsize overload(byval txt as string, byval font as FT_Face, _
                     byval size as integer = FONTSIZE.NORMAL) as TCoord
declare function FTsize(byval txtptr as wstring ptr, byval font as FT_Face, _
                     byval size as integer = FONTSIZE.NORMAL) as TCoord
declare function getFont(byval fontName as string) as FT_Face
declare sub centerFT overload(img as FB.Image ptr, txt as string, font as FT_Face, _
                     size as integer = FONTSIZE.NORMAL, clr as uinteger = 0)
declare sub centerFT(x as integer, y as integer, txt as string, font as FT_Face, _
                     size as integer = FONTSIZE.NORMAL, clr as uinteger = 0)
declare function printFT overload(txt as string, font as FT_Face, _
                     size as integer = FONTSIZE.NORMAL, clr as uinteger = 0) as FB.Image ptr
declare function printFT(x as integer, y as integer, txt as string, font as FT_Face, _
                     size as integer = FONTSIZE.NORMAL, clr as uinteger = 0, bmpPtr as FB.Image ptr = 0) as boolean
declare function utf2ansi(txt as string) as string
declare function wordLength(w as string) as integer

sub drawGlyph(img as FB.Image ptr, byval font As FT_Face, byval x as integer, byval y as integer, byval clr as uinteger)
  #ifndef FBGFX_FALLBACK
    if img = 0 then exit sub
    dim as FT_Bitmap BmpFT
    dim as ubyte ptr BmpPtr
    dim as ulong ptr dstPtr, startPtr
    dim as integer   BmpHeight, BmpWidth, BmpPitch
    dim as uinteger  srcRB, srcAG, dstRB, dstAG, dstClr, alph
  
    bmpFT     = font->Glyph->Bitmap
    bmpPtr    = bmpFT.Buffer
    bmpWidth  = bmpFT.Width
    bmpHeight = bmpFT.Rows

    startPtr = cast(ulong ptr, img) + 8
    dstPtr = startPtr + y*img->Pitch\img->bpp + x
    do while bmpHeight
      do while bmpWidth
        if dstPtr >= startPtr then
          srcRB    = clr and FT_MASK_RB_32
          srcAG    = clr and FT_MASK_AG_32
          dstClr   = *dstPtr
          alph     = *bmpPtr
          dstRB    = dstClr and FT_MASK_RB_32
          dstAG    = dstClr and FT_MASK_AG_32
          srcRB    = ((srcRB - dstRB) * alph) shr 8
          srcAG    = ((srcAG  - dstAG) shr 8)  * alph
          *dstPtr  = ((dstRB + srcRB) and FT_MASK_RB_32) or ((dstAG + srcAG) and FT_MASK_AG_32)
        end if
        dstPtr   += 1
        bmpPtr   += 1
        bmpWidth -= 1
      loop
      bmpWidth  = bmpFT.Width
      bmpHeight -= 1
      dstPtr += img->pitch\img->bpp - bmpFT.Width
    loop
  #endif
end sub

function FTsize(byval txt as string, byval font as FT_Face, byval size as integer = FONTSIZE.NORMAL) as TCoord
  #ifdef FBGFX_FALLBACK
    return type<TCoord>(len(txt)*8, 16)
  #else
    dim as wstring*MAX_TEXTSIZE wtxt
    dim as integer txtSize = len(txt)
    UTFToWChar(UTF_ENCOD_UTF8, strptr(txt), @wtxt, @txtSize)
    return FTsize(@wtxt, font, size)
  #endif
end function

function FTsize(byval txtptr as wstring ptr, byval font as FT_Face, byval size as integer = FONTSIZE.NORMAL) as TCoord
  #ifdef FBGFX_FALLBACK
    return type<TCoord>(len(*txtptr)*8, 16)
  #else
    dim as FT_Error ErrorMsg
    dim as FT_UInt GlyphIndex
    dim as FT_GlyphSlot slot = font->Glyph
    dim as wstring*MAX_TEXTSIZE txt = *txtptr
    dim as integer px = 2, py = 0, tempInt
    if FT_Set_Pixel_Sizes(font, size, size) then return TCoord(-1, -1)
    FT_Var.PixelSize = size

    for i as integer = 0 to len(txt)-1
      GlyphIndex = FT_Get_Char_Index(font, txt[i])
      if FT_Load_Glyph(font, GlyphIndex, FT_LOAD_DEFAULT) then return TCoord(-1, -1)
      px += slot->Advance.x shr 6
    next
    GlyphIndex = FT_Get_Char_Index(font, 124)
    if FT_Load_Glyph(font, GlyphIndex, FT_LOAD_DEFAULT) then return TCoord(-1, -1)
    if FT_Render_Glyph(slot, FT_RENDER_MODE_NORMAL) then return TCoord(-1, -1)
    py = slot->metrics.height\64+2*(size-slot->Bitmap_Top)
    return TCoord(px, py)
  #endif
end function

function getFont(byval fontName as string) as FT_Face
  #ifdef FBGFX_FALLBACK
    return -1
  #else
    dim face as FT_Face
    dim ErrorMsg as FT_Error
    ErrorMsg = FT_New_Face(FT_Var.Library, fontName, 0, @face)
    if ErrorMsg then return 0
    return face
  #endif
end function

sub centerFT(img as FB.Image ptr, txt as string, font as FT_Face, _
             size as integer = FONTSIZE.NORMAL, clr as uinteger = 0)
  if img = 0 then exit sub
  dim as FB.Image ptr tempImg = printFT(txt, font, size, clr)
  dim as integer sx, sy, dx, dy, w, h
  if tempImg then
    if tempImg->width >= img->width then
      sx = 0
      dx = (tempImg->width-img->width)\2
      w  = img->width-1
    else
      sx = (img->width-tempImg->width)\2 + 1
      dx = 0
      w  = tempImg->width-1
    end if
    if tempImg->height-4 >= img->height then
      sy = 4
      dy = (tempImg->height-img->height)\2
      h  = img->height-1
    else
      sy = (img->height-tempImg->height+4)\2
      dy = 0
      h  = tempImg->height-1
    end if
    #ifdef FBGFX_FALLBACK
      put img, (sx, sy), tempImg, (dx, dy)-step(w, h)
    #else
      put img, (sx, sy), tempImg, (dx, dy)-step(w, h), alpha
    #endif
    imagedestroy tempImg
  end if
end sub

sub centerFT(x as integer, y as integer, txt as string, font as FT_Face, _
             size as integer = FONTSIZE.NORMAL, clr as uinteger = 0)
  dim as TCoord textsize = FTsize(txt, font, size)
  printFT x-textsize.x\2, y-textsize.y\2, txt, font, size, clr
end sub

function printFT(txt as string, font as FT_Face, size as integer = FONTSIZE.NORMAL, clr as uinteger = 0) as FB.Image ptr
  #ifdef FBGFX_FALLBACK
    dim as FB.Image ptr img = imagecreate(len(txt)*8, 12, 0)
    draw string img, (0, 0), utf2ansi(txt), not clr
  #else
    dim as wstring*MAX_TEXTSIZE wtxt
    dim as integer txtSize = len(txt)
    UTFToWChar(UTF_ENCOD_UTF8, strptr(txt), @wtxt, @txtSize)
    dim as TCoord imgSize = FTsize(@wtxt, font, size)
    imgSize.x += 4
    dim as FB.Image ptr img = imagecreate(imgSize.x, imgSize.y, 0)
    dim as FT_UInt GlyphIndex
    dim as FT_GlyphSlot slot
    dim as integer px = 3, py = 0
    clr or= &hff000000
    if FT_Set_Pixel_Sizes(font, size, size) then imagedestroy img : return 0
    FT_Var.PixelSize = size
    slot = font->Glyph

    dim as integer i = 0, curColor = clr
    do while i < len(wtxt)
      GlyphIndex = FT_Get_Char_Index(font, wtxt[i])
      if FT_Load_Glyph(font, GlyphIndex, FT_LOAD_DEFAULT) then imagedestroy img : return 0
      if FT_Render_Glyph(slot, FT_RENDER_MODE_NORMAL) then imagedestroy img : return 0
      ' set pixels
      drawGlyph img, font, px + slot->Bitmap_Left, py - slot->Bitmap_Top + size, curColor
      px += slot->Advance.x shr 6
      i += 1
    loop
  #endif
  return img
end function

function printFT(x as integer, y as integer, txt as string, font as FT_Face, _
                 size as integer = FONTSIZE.NORMAL, clr as uinteger = 0, bmpPtr as FB.Image ptr = 0) as boolean
  #ifdef FBGFX_FALLBACK
    draw string bmpPtr, (x, y), utf2ansi(txt), clr
  #else
    dim as FB.Image ptr img = printFT(txt, font, size, clr)
    if img = 0 then return false
    put bmpPtr, (x, y), img, alpha
    imagedestroy img
  #endif
  return true
end function

function utf2ansi(txt as string) as string
  ' translate UTF8-string to ANSI codepage 437
  dim as integer k, char(127 to 255) = { &h08FE,  _
         &h00C7, &h00FC, &h00E9, &h00E2, &h00E4, &h00E0, &h00E5, &h00E7,  _
         &h00EA, &h00EB, &h00E8, &h00EF, &h00EE, &h00EC, &h00C4, &h00C5,  _
         &h00C9, &h00E6, &h00C6, &h00F4, &h00F6, &h00F2, &h00FB, &h00F9,  _
         &h00FF, &h00D6, &h00DC, &h00A2, &h00A3, &h00A5, &h20A7, &h0192,  _
         &h00E1, &h00ED, &h00F3, &h00FA, &h00F1, &h00D1, &h00AA, &h00BA,  _
         &h00BF, &h2310, &h00AC, &h00BD, &h00BC, &h00A1, &h00AB, &h00BB,  _
         &h2591, &h2592, &h2593, &h2502, &h2524, &h2561, &h2562, &h2556,  _
         &h2555, &h2563, &h2551, &h2557, &h255D, &h255C, &h255B, &h2510,  _
         &h2514, &h2534, &h252C, &h251C, &h2500, &h253C, &h255E, &h255F,  _
         &h255A, &h2554, &h2569, &h2566, &h2560, &h2550, &h256C, &h2567,  _
         &h2568, &h2564, &h2565, &h2559, &h2558, &h2552, &h2553, &h256B,  _
         &h256A, &h2518, &h250C, &h2588, &h2584, &h258C, &h2590, &h2580,  _
         &h03B1, &h00DF, &h0393, &h03C0, &h03A3, &h03C3, &h00B5, &h03C4,  _
         &h03A6, &h0398, &h03A9, &h03B4, &h221E, &h03C6, &h03B5, &h2229,  _
         &h2261, &h00B1, &h2265, &h2264, &h2320, &h2321, &h00F7, &h2248,  _
         &h00B0, &h2219, &h00B7, &h221A, &h207F, &h00B2, &h25A0, &h00A0 }
  dim as integer size = wordLength(txt)
  dim as string ret = space(size)
  dim as wstring ptr wTxt = allocate((size+1)*sizeof(wstring))
  UTFToWChar(UTF_ENCOD.UTF_ENCOD_UTF8, strptr(txt), wTxt, @size)

  for i as integer = 0 to size-1
    if wTxt[i] < 127 then
      k = wTxt[i]
    else
      for k = 127 to 255
        if char(k) = wTxt[i] then exit for
      next
    end if
    ret[i] = iif(k = 256, 63, k)
  next
  deallocate wTxt
  return ret
end function

function wordLength(w as string) as integer
  ' returns the size of a utf8-string 'w' in WString chars (e.g. wordLength("¿Qué?") returns 5)
  dim as integer txtSize = len(w), ret
  dim as zstring ptr zptr = callocate(txtSize+1)
  UTFToChar(UTF_ENCOD_UTF8, strptr(w), zptr, @txtSize)
  ret = len(*zptr)
  deallocate zptr
  return ret
end function
