#include once "dir.bi"

#ifdef __FB_UNIX__
  dim as string pre = "liblengua_", ending = ".so", resource = "icon.xpm"
  dim as string fbcpath = ""
#elseif defined(__FB_PCOS__)
  dim as string pre = "lengua_", ending = ".dll", resource = "resource.rc"
  dim as string fbcpath = "C:\Programme\FreeBASIC\"
  chdir exepath
#else
  #error "CRITICAL ERROR: system not supported"
#endif

dim as string language
mkdir exepath & "/include"
mkdir exepath & "/include/modules"
mkdir exepath & "/export"

print "compile lengua (main program)"
shell fbcpath & "fbc " & exepath & "/lengua.bas " & exepath & "/" & resource

language = dir(exepath & "\include\modules\*", fbDirectory or fbArchive)
do while len(language)
  if language <> "." and language <> ".." then
    print "compile include/modules/" & pre & language & ending
    mkdir exepath & "/modules/" & language
    mkdir exepath & "/export/" & language
    shell fbcpath & "fbc " & exepath & "/include/modules/" & language & "/basic.bas "_
                  & exepath & "/include/modules/" & language & "/" & resource & " -dll -x " _
                  & exepath & "/modules/" & pre & language & ending
  end if
  language = dir
loop
