' definitions for the main program and all modules

const API_VERSION = (1 shl 16) + 0, OPTIONS_FILENAME = ".lengua-settings"
declare function checkMouseIn(x as integer, y as integer, w as integer, h as integer, b as integer = -1) as boolean

type TModule
  as string libname, libshort, title
  as long major, minor, patch, api = API_VERSION
  declare constructor
  declare constructor(l as string, t as string, ma as long, mi as long, pa as long)
end type
constructor TModule
end constructor
constructor TModule(l as string, t as string, ma as long, mi as long, pa as long)
  libname = l
  title   = t
  major   = ma
  minor   = mi
  patch   = pa
end constructor

enum MAIN_ERROR
  none = 0, missingFont
end enum

function checkMouseIn(x as integer, y as integer, w as integer, h as integer, b as integer = -1) as boolean
  ' returns whether the mouse cursor is inside the given coordinates
  dim as integer mouseX, mouseY, mouseB
  if getmouse(mouseX, mouseY,, mouseB) <> 0 then return false
  if b >= 0 andalso mouseB <> b then return false
  return (mouseX > x and mouseY > y and mouseX < x+w and mouseY < y+h)
end function
